models/Productos.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "productos".
 *
 * @property int $id
 * @property string|null $nombre
 * @property string|null $foto
 * @property int|null $almacen
 * @property string|null $fecha
 *
 * @property Almacenes $almacen0
 */
class Productos extends \yii\db\ActiveRecord
{
    public $actualizarFoto;
    
    
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'productos';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['almacen'], 'integer'],
            [['fecha'], 'safe'],
            [['nombre'], 'string', 'max' => 255],
            [['foto'], 'file', 'skipOnEmpty' => true, 'extensions' => 'png, jpg'],
            [['almacen'], 'exist', 'skipOnError' => true, 'targetClass' => Almacenes::className(), 'targetAttribute' => ['almacen' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'nombre' => 'Nombre',
            'foto' => 'Foto',
            'almacen' => 'Almacen',
            'fecha' => 'Fecha',
        ];
    }

    /**
     * Gets query for [[Almacen0]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getAlmacen0()
    {
        return $this->hasOne(Almacenes::className(), ['id' => 'almacen']);
    }
    
           
    
    public function afterFind() {
        parent::afterFind();
        $this->fecha=Yii::$app->formatter->asDate($this->fecha, 'php:d/m/Y');
    }

    
    public function beforeSave($insert) {
        parent::beforeSave($insert);
        
        // poder introducir la fecha en castellano
        $this->fecha= \DateTime::createFromFormat("d/m/Y", $this->fecha)->format("Y/m/d");
        
        /* tema subida archivos */
        $this->actualizarFoto=TRUE;
        /* si no ha subido ningun fichero recupero el valor anterior de los ficheros */
        if(!isset($this->foto)){
            $this->foto=$this->getOldAttribute("foto");
            $this->actualizarFoto=FALSE;
        }
        
        return true;
        
    }

 
    public function afterSave($insert, $changeAttributes) {

        /* comprobar si ha seleccionado algun archivo */
        /* ademas comprobamos que sea un fichero lo que me llegue*/
        /* esto es para que si estoy borrando no me de problemas */
        /* llegaria un string en ese caso */
        
        if($this->actualizarFoto){
            
            
            $this->foto->saveAs('imgs/' . $this->id . iconv('UTF-8','ISO-8859-1',$this->foto->name), false);
            $this->foto = $this->id . iconv('UTF-8','ISO-8859-1', $this->foto->name);
        }
        
        //almacenar los cambios
        $this->updateAttributes(["foto"]);
    }
    
    
     public function getFoto() {
       return Yii::$app->request->getBaseUrl() . '/imgs/' . $this->foto;
    }

}

controllers/ProductosController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Productos;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\web\UploadedFile;

/**
 * ProductosController implements the CRUD actions for Productos model.
 */
class ProductosController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Productos models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Productos::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }
        
    /**
     * Displays a single Productos model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Productos model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Productos();
        
                
        if ($model->load(Yii::$app->request->post())) {
            $model->foto = UploadedFile::getInstance($model, 'foto');
            if ($model->save()) {
                return $this->redirect(['view', 'id' => $model->id]);
            }
        }

        return $this->render('create', [
                    'model' => $model,
        ]);

    }

    /**
     * Updates an existing Productos model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
        
        if ($model->load(Yii::$app->request->post())) {
            // intentamos recuperar el fichero subido (actualizado)
            // en caso de que no seleccione ninguno el metodo estatico
            // devuelve null
            $model->foto = UploadedFile::getInstance($model, 'foto');

            if ($model->save()) {
                return $this->redirect(['view', 'id' => $model->id]);
            }
        }

        return $this->render('update', [
            'model' => $model,
        ]);

    }

    /**
     * Deletes an existing Productos model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Productos model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Productos the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Productos::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    public function actionEliminar($id){
        $model = $this->findModel($id);
        $model->foto=null;
        $model->save();
        return $this->redirect(['view', 'id' => $model->id]);
    }

}

views/productos/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use app\models\Almacenes;
use yii\helpers\ArrayHelper;
use kartik\date\DatePicker;
use yii\bootstrap\Alert;
/* @var $this yii\web\View */
/* @var $model app\models\Productos */
/* @var $form yii\widgets\ActiveForm */


    $almacenes=Almacenes::find()->all();
    $datos=ArrayHelper::map($almacenes,'id','nombre');


?>

<div class="productos-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

      <?= $form->field($model, 'foto')->fileInput() ?>
    
    <?php
    if (!empty($model->foto)) {
        echo Alert::widget([
            'body' => Html::img($model->getFoto(), [
                'class' => 'img-responsive img-thumbnail',
            ]),
            'closeButton' => [
                'tag' => 'a',
                'href' => \yii\helpers\Url::to(['productos/eliminar', 'id' => $model->id]),
            ],
        ]);
    }
    ?>


    <?= $form->field($model, 'almacen')->dropDownList(
            $datos,
            ['prompt'=>'Selecciona un almacen']
        );?>

    <?php    
    echo '<label class="control-label">Fecha</label>';
    echo DatePicker::widget([
        'model' => $model, 
        'attribute' => 'fecha',
        'language' => 'es',
        'options' => ['placeholder' => 'Introduce fecha'],
        'pluginOptions' => [
            'todayHighlight' => true,
            'todayBtn' => true,
            'format' => 'dd/mm/yyyy',
            'autoclose' => true,
        ]
    ]);
    ?>


    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/productos/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Productos */

$this->title = 'Create Productos';
$this->params['breadcrumbs'][] = ['label' => 'Productos', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="productos-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/productos/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Productos';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="productos-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Productos', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            'id',
            'nombre',
            //'foto',
            [
                'label'=>'Imagen del producto',
                'attribute'=>'foto',
                'format'=>'raw',
                'contentOptions'=>['style'=>'text-align:center'],
                'value'=>function($d){
                    return Html::img("@web/imgs/" . $d->foto,['width'=>'100px']);
                }
            ],
            //'almacen',
            'fecha',
            //'almacen0.nombre',
            //'almacen0.direccion',
            [
                'label'=>'datos del almacen',
                'attribute'=>'almacen',
                'format'=>'raw',
                'value'=>function($d){
                    return $d->almacen . 
                            '<br>' . 
                            $d->almacen0->nombre .
                            '<br>' .
                            $d->almacen0->direccion;
                }
            ],
            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/productos/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Productos */

$this->title = 'Update Productos: ' . $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Productos', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="productos-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/productos/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Productos */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Productos', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="productos-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'nombre',
            'foto',
            'almacen',
            'fecha',
        ],
    ]) ?>

</div>